#include "adc.h"
#include "stm32l0xx.h"

#define MaxClockCycle 0x07


uint16_t adc_dma_data[2];

volatile uint8_t done;

void adc_dma_tim_init(void)
{

	/****Configure gpio pin for adc***/
	/*Enable clock access to GPIOA*/
	RCC->IOPENR |=RCC_IOPENR_IOPAEN;

	/*Set pa4 mode to analog mode*/
	GPIOA->MODER |=GPIO_MODER_MODE0|GPIO_MODER_MODE1;


	/******Configure the adc module******/
	/*Enable clock access to ADC*/
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN;
	/*Enable external trigger on rising edge*/
	ADC1->CFGR1|=ADC_CFGR1_EXTEN_0;
	/*Select TRG2 (TIM2_TRGO)*/
	ADC1->CFGR1|=ADC_CFGR1_EXTSEL_1;

	/*Set sequencer channel*/
	ADC1->CHSELR |=ADC_CHSELR_CHSEL0|ADC_CHSELR_CHSEL1;

	/*Set clock to be CLCK/2*/

	ADC1->CFGR2|=ADC_CFGR2_CKMODE_0;

	/*Configure TIM2*/
	/*Enable clock access to TIM2*/
	RCC->APB1ENR|=RCC_APB1ENR_TIM2EN;
	TIM2->CR2|=TIM_CR2_MMS_1;
	TIM2->PSC=2097;
	TIM2->ARR=1000;

	/*Enable ADC DMA*/
	ADC1->CFGR1|=ADC_CFGR1_DMAEN;

	/*Configure DMA*/
	RCC->AHBENR|=RCC_AHBENR_DMA1EN;
	DMA1_Channel1->CCR|=DMA_CCR_MSIZE_0|DMA_CCR_PSIZE_0|DMA_CCR_MINC|DMA_CCR_CIRC|DMA_CCR_TCIE;
	NVIC_EnableIRQ(DMA1_Channel1_IRQn);
	DMA1_Channel1->CNDTR=sizeof(adc_dma_data)/sizeof(adc_dma_data[0]);
	DMA1_Channel1->CPAR= (uint32_t)(&ADC1->DR);
	DMA1_Channel1->CMAR=(uint32_t)(&adc_dma_data);
	DMA1_Channel1->CCR|=DMA_CCR_EN;
	ADC1->CFGR1|=ADC_CFGR1_DMACFG;
	ADC1->CR |= ADC_CR_ADCAL;
	while(ADC1->CR & ADC_CR_ADCAL);
	ADC1->CR |= ADC_CR_ADEN;
	/*Start conversion*/
	ADC1->CR |= ADC_CR_ADSTART;

	/*Enable TIM2*/
	TIM2->CR1|=TIM_CR1_CEN;

}

uint16_t get_adc_value (adc_Channel channel)
	{
	return adc_dma_data[channel];

	}




void DMA1_Channel1_IRQHandler (void)
	{
		if(DMA1->ISR & DMA_ISR_TCIF1)
			{
				done=1;
				DMA1->IFCR|=DMA_IFCR_CTCIF1;

			}

	}
